# We use a job template to avoid mindless repetition.  All of our jobs
# run 'tox', and we vary which tox environment they run or which
# Python version they use by overriding the 'TOXENV' environment
# variable or the 'image' job parameter.
#
# The name of the template starts with a dot to prevent GitLab from
# running it as an actual job.
.tox:
  image: python:latest
  before_script:
    - pip install tox
  script:
    - tox
  variables:
    TOXENV: py
    # The environment 'py' uses the version of Python used to invoke tox,
    # which allows us to test various Python versions by changing the
    # Docker image version in use.

# the main test suite, for each python version
test:
  extends: .tox
  # match this list of python versions with the classifiers variable
  # in setup.py. see also the list in .gitlab-ci.yml, which is
  # specific to the docker container running the tests
  parallel:
    matrix:
      - IMAGE:
          - python:3.9 # Debian 11 bullseye
  image: $IMAGE
  allow_failure: true

flake8:
  extends: .tox
  variables:
    TOXENV: flake8

black:
  extends: .tox
  variables:
    TOXENV: black

mypy:
  extends: .tox
  variables:
    TOXENV: mypy
  allow_failure: true
